<?php

require_once '/var/www/php/site.php';
require_once '/var/www/house/applets/mixcontrol.inc';
require_once 'utils.inc';
require_once 'DB.php';

$dbbackend='mysql';
$dbhost = 'localhost';
$dbuser = 'www-data';
$dbpass = '';
$dbname = 'radio';

function SwitchRadioOff()
{
global $status_text;

	if (!IsUserValidFor("radio", "w"))      return;

	$cmd = "fm off";
	$status_text = "<i>".$cmd."</i><br>".shell_exec($cmd);
}

function SetRadio($freq)
{
global $radio_freq;
global $status_text;

	if (!IsUserValidFor("radio", "w"))	return;

	$cmd = "fm ";

	$radio_freq = $freq;
	$cmd .= escapeshellcmd($radio_freq);
	$cmd .= " 65535";

	$status_text = "<i>".$cmd."</i><br>".shell_exec($cmd);
}

function RadioPoll()
{
global $radio_freq;

//$radio_freq = 91.3;

// retrieve from h/w

}

function RenderPanel(&$webface)
{
global $status_text;

$panel = '<FONT SIZE="1">'.$status_text.'</FONT><BR>';


return $panel;
}

function GetStationList()
{
global $dbname, $dbhost, $dbuser, $dbbackend;

	if (!IsUserValidFor("radio", "r"))	return;

	$dsn = "$dbbackend://$dbuser@$dbhost/$dbname";
	$db =& DB::connect($dsn);

	if (DB::isError($db))		return "Could not connect to DB: ".$db->getMessage();

	$stations = array();

	/* Performing SQL query */
	$query = "SELECT freq.freq,freq.name FROM radio.freq";
	#$query.= " ORDER BY unsigned_integer freq.freq";
	$result = $db->query($query);

	if ($result)
		{
		while ($row = $result->fetchRow()) {
			$stations[$row[1]] = $row[0];
		}

    		/* Free resultset */
    		$result->free();
		}
	else
		{
		$html = "Query failed: ";
		}

    	/* Closing connection */
	$db->disconnect();

return $stations;
}

function GetStationName($freq)
{
global $dbname, $dbhost, $dbuser, $dbbackend;

	if (!IsUserValidFor("radio", "r"))	return "";

	$dsn = "$dbbackend://$dbuser@$dbhost/$dbname";
	$db =& DB::connect($dsn);

	if (DB::isError($db))			return "";

        /* Performing SQL query */
        $query = "SELECT freq.name FROM radio.freq WHERE freq.freq=$freq";
        $result = $db->query($query);

	if (!DB::isError($result))
	{
		$row = $result->fetchRow();
                $name = $row[0];
		$result->free();
	}
	$db->disconnect();

return $name;
}



function RadioPane1(&$webface) { 
global $stations, $radio_freq;

$table = '<TABLE CELLSPACING="1" CELLPADDING="0" WIDTH="100%">';
$table.= '<TR><TD><b>Station Name</b></TD><TD><b>Frequency</b></TD></TR>';

$table .= "<TR><TD>";
$table .= $webface->ctrl->createAnchor("off", "1", "Off");
$table .= "</TD><TD>&nbsp;</TD></TR>";

$stations = GetStationList();
$table .= $results;
foreach ($stations as $name => $freq)
{
	if (IsUserValidFor("radio", "w"))
		$txt = $webface->ctrl->createAnchor("freq", $freq, $name);
	else
		$txt = $name;

	$table .= "<TR><TD>$txt</TD><TD>${freq}</TD></TR>\n";
}

$table.="</TABLE>";
return $table;
}

function getLeftIcon()
{
    return '<IMG SRC="/icons/left.gif" BORDER="0" ALT="&lt;-">';
}

function getRightIcon()
{
    return '<IMG SRC="/icons/right.gif" BORDER="0" ALT="-&gt;">';
}

function GetLeft(&$webface)
{
global $radio_freq;

$left = getLeftIcon();
$disp = $webface->ctrl->createAnchor("freq",($radio_freq-0.05), $left);
return $disp;
}

function GetRight(&$webface)
{
global $radio_freq;

$right= getRightIcon();
$disp = $webface->ctrl->createAnchor("freq",($radio_freq+0.05), $right);
return $disp;
}

function RadioPanel(&$webface)
{
global $radio_freq;
global $status_text;

	$html.= "<div align=center>";
	$html.= "<i><b>".GetStationName($radio_freq)."</b></i><br>";

	$html.= "Freq: ";
	$html.= GetLeft($webface)."&nbsp;".$radio_freq."&nbsp;".GetRight($webface);
	$html .= '<BR>';
	$html .= $webface->ctrl->createAnchor("scandown",$radio_freq, getLeftIcon());
	$html .= "&nbsp;Scanning&nbsp;";
	$html .= $webface->ctrl->createAnchor("scanup",$radio_freq, getRightIcon());
	$html .= '<BR>';

        // Add volume control
        $volCtrl = new Mixer_Control("line");
        $vol = $volCtrl->getVolume();

        $html .= Web_Face_renderSliderBar($webface, $vol, 100, 5, "rvol", "im", 3, WARP_SLIDER_NUMBER_NONE)."<br>";

	$html.= "</div>";
	$html.= "<div align=right>";
	$html.= $webface->ctrl->createAnchor("off", "1", "Off");
	$html.="</div>";

	return $html;
}

function RadioPane2(&$webface) {
global $radio_freq;
global $status_text;

if ($radio_freq == 0)	return;
if (!IsUserValidFor("radio", "r"))	return;

$disp='<DIV ALIGN="CENTER">';
$disp .= '<b><h1>'.GetStationName($radio_freq).'</h1></b>';

$str = substr("0".number_format($radio_freq, 2), -6);
$num = strlen($str);
for($i=0;$i<$num;$i++)
{
$ss = substr($str, $i, 1);
if ($ss == '.')
	$disp .= '<IMG SRC="radio/pix/colon.png" ALT=":">&nbsp;';
else if (is_numeric($ss))
	$disp .= '<IMG SRC="radio/pix/'.$ss.'.png" ALT="'.$ss.'">&nbsp;';

}

$disp .= '<BR>';
$disp .= $webface->ctrl->createAnchor("scandown",$radio_freq, getLeftIcon());
$disp .= "&nbsp;Scanning&nbsp;";
$disp .= $webface->ctrl->createAnchor("scanup",$radio_freq, getRightIcon());

$disp .= '<BR>';
$disp .= GetLeft($webface)."&nbsp;Tuning&nbsp;".GetRight($webface);

if (!IsUserValidFor("radio"))
	$disp.= "<BR><BR><I>You are not authorised to re-tune the radio!</I>";

$disp .= '</DIV>';

$disp.= "<br><br>";
$disp.= $status_text;
return $disp;
}

function scanRadioFrom($freq, $direction)
{
	if ($direction < 0) {
		return getPreviousStation($freq);
	} else if ($direction > 0) {
		return getNextStation($freq);
	}
	else {
		return $freq;
	}
	
}

function getPreviousStation($currFreq)
{
	$stations = GetStationList();
	$diff = 999;
	$prev = $currFreq;

	foreach ($stations as $name => $freq)
	{
		if ($freq < $currFreq) {
			$d = $currFreq - $freq;
			if ($d != 0 && $d < $diff) {
				$diff = $d;
				$prev = $freq;
			}
		}
	}

	return $prev;
}

function getNextStation($currFreq)
{
	$stations = GetStationList();
	$diff = 999;
	$next = $currFreq;

	foreach ($stations as $name => $freq) {
		if ($freq > $currFreq) {
			$d = $freq - $currFreq;
			if ($d != 0 && $d < $diff) {
				$diff = $d;
				$next = $freq;
			}
		}
	}

	return $next;
}

function ProcessRadio(&$app_man)
{
global $radio_freq;

$scanup = $app_man->webface->ctrl->getParameterValue("scanup");
$scandn = $app_man->webface->ctrl->getParameterValue("scandown");
$freq = $app_man->webface->ctrl->getParameterValue("freq");
$off  = $app_man->webface->ctrl->getParameterValue("off");

$vol = $app_man->webface->ctrl->getParameterValue("rvol");

if ($vol != "") {
        $volCtrl = new Mixer_Control("line");
        $volCtrl->setVolume($vol);
}

$radio_freq = $freq;

if ($scanup != "")
	$freq = getNextStation($scanup);
if ($scandn != "")
	$freq = getPreviousStation($scandn);

if ($off != "")
	SwitchRadioOff();
else if ($freq != "")
	SetRadio($freq);
else
	$radio_freq = 100.4;
}

?>

